#!/bin/sh

tdc_inst_dest="/var/opt/tableau/tableau_server/data/tabsvc/vizqlserver/Datasources/"
if [ -d $tdc_inst_dest ]; then
  sudo cp -a ./TDC/. $tdc_inst_dest 
fi

filename="/etc/qubole.odbc.ini"
if [ -f $filename ]; then
 sudo rm $filename
fi

#create this file in /etc/ for system level configs
cat > /etc/qubole.odbc.ini << quboleEOF
[Driver]

## Note that this default DriverManagerEncoding of UTF-32 is for iODBC
DriverLocale=en-US
ErrorMessagesPath=ErrorMessages/
LogLevel=0
LogPath=/tmp
SwapFilePath=/tmp
CertificatePath=/usr/local/qubole/
quboleEOF

cd /usr/local/qubole

#Creating sample configuration file for ALLEngines 
cat > odbc.ini << quboleEOF
[ODBC]
# Specify any global ODBC configuration here such as ODBC tracing.

[ODBC Data Sources]
Qubole ODBC Driver DSN=QuboleODBC

[Qubole ODBC Driver DSN]
# This key is not necessary and is only to give a description of the data source.
Description=Qubole ODBC Driver DSN

# Driver: The location where the ODBC driver is installed to.
Driver=/usr/local/qubole/libquboleodbc.so
# APITOKEN: The API Token for the account to be used, as provided by Qubole.
APITOKEN=""
# CLUSTER_LABEL: The label of the cluster on which queries are to be run
CLUSTER_LABEL=default
# ENDPOINT: The endpoint for the account to be used, as provided by Qubole. 
ENDPOINT=https://api.qubole.com
#DSI: The data source name : Hive, Spark, Presto, or SQLCommand 
DSI=hive
APPID=""
quboleEOF

cat > odbcinst.ini << quboleEOF
[ODBC Drivers]
QuboleODBC=Installed

[QuboleODBC]
Description=Qubole ODBC Driver DSN
Driver=/usr/local/qubole/libquboleodbc.so
quboleEOF


#create system DSN entries in /etc/
touch /etc/odbcinst.ini
dsn_odbc_inst_ini_ln_sys=`grep -n "\[ODBC Drivers\]" /etc/odbcinst.ini | cut -f1 -d:`
if [ ! -z "$dsn_odbc_inst_ini_ln_sys" ]; then
	qubole_entry=`grep -n "QuboleODBC=Installed" /etc/odbcinst.ini | cut -f1 -d:`
	if [ -z "$qubole_entry" ]; then
		((dsn_odbc_inst_ini_ln_sys++))
		sudo sed -i ${dsn_odbc_inst_ini_ln_sys}'i\QuboleODBC=Installed\' /etc/odbcinst.ini

sudo cat >> /etc/odbcinst.ini << quboleEOF
[QuboleODBC]
Description=Qubole ODBC Driver DSN
Driver=/usr/local/qubole/libquboleodbc.so
quboleEOF
fi
else
	sudo cp /usr/local/qubole/odbcinst.ini /etc/odbcinst.ini
fi

odbc_ini_file="/etc/odbc.ini"
newline_flag=false
if [ ! -f $odbc_ini_file ]; then
	#replace file only if it doesn't already exist
	sudo cp /usr/local/qubole/odbc.ini /etc/odbc.ini
else
	dsn_odbc_ini_ln_sys=`grep -n "\[ODBC Data Sources\]" /etc/odbc.ini | cut -f1 -d:`
	if [ -z "$dsn_odbc_ini_ln_sys" ]; then
		#create this section if it doesn't exist already
		sed -i '1 i\[ODBC Data Sources\]' /etc/odbc.ini
		dsn_odbc_ini_ln_sys=1
		newline_flag=true
	fi
	qubole_ini_entry=`grep -n "Qubole ODBC Driver DSN=QuboleODBC" /etc/odbc.ini | cut -f1 -d:`
	if [ -z "$qubole_ini_entry" ]; then
		#if the entry for qubole driver is not present then create it
		((dsn_odbc_ini_ln_sys++))
		if $newline_flag ; then
			sudo sed -i ${dsn_odbc_ini_ln_sys}'i\Qubole ODBC Driver DSN=QuboleODBC\
			' /etc/odbc.ini
		else 
			sudo sed -i ${dsn_odbc_ini_ln_sys}'i\Qubole ODBC Driver DSN=QuboleODBC\' /etc/odbc.ini
		fi
sudo cat >> /etc/odbc.ini << quboleEOF

[Qubole ODBC Driver DSN]

# This key is not necessary and is only to give a description of the data source.
Description=Qubole ODBC Driver DSN

# Driver: The location where the ODBC driver is installed to.
Driver=/usr/local/qubole//libquboleodbc.so
# APITOKEN: The API Token for the account to be used, as provided by Qubole.
APITOKEN=""
# CLUSTER_LABEL: The label of the cluster on which queries are to be run
CLUSTER_LABEL=default
# ENDPOINT: The endpoint for the account to be used, as provided by Qubole. 
ENDPOINT=https://api.qubole.com
DSI=hive
APPID=""
quboleEOF
	fi
fi
